<?php
namespace Neos\Flow\Persistence\Doctrine\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs! This block will be used as the migration description if getDescription() is not used.
 */
class Version20160922081426 extends AbstractMigration
{

    /**
     * @return string
     */
    public function getDescription()
    {
        return '';
    }

    /**
     * @param Schema $schema
     * @return void
     */
    public function up(Schema $schema)
    {
        // this up() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on "mysql".');
        
        $this->addSql('CREATE TABLE one50_shop_domain_model_category (persistence_object_identifier VARCHAR(40) NOT NULL, title VARCHAR(120) NOT NULL, description VARCHAR(255) NOT NULL, PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE one50_shop_domain_model_order (persistence_object_identifier VARCHAR(40) NOT NULL, user VARCHAR(40) DEFAULT NULL, transactionid VARCHAR(20) NOT NULL, status INT NOT NULL, INDEX IDX_D32913048D93D649 (user), PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE one50_shop_domain_model_product (persistence_object_identifier VARCHAR(40) NOT NULL, category VARCHAR(40) DEFAULT NULL, title VARCHAR(120) NOT NULL, description VARCHAR(255) NOT NULL, price INT NOT NULL, INDEX IDX_E306649B64C19C1 (category), PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE one50_shop_domain_model_product_images_join (shop_product VARCHAR(40) NOT NULL, flow_resource_resource VARCHAR(40) NOT NULL, INDEX IDX_BF375517D0794487 (shop_product), INDEX IDX_BF37551714E3D2D7 (flow_resource_resource), PRIMARY KEY(shop_product, flow_resource_resource)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE one50_shop_domain_model_user (persistence_object_identifier VARCHAR(40) NOT NULL, firstname VARCHAR(80) NOT NULL, lastname VARCHAR(80) NOT NULL, street VARCHAR(80) NOT NULL, streetnumber VARCHAR(10) NOT NULL, zip INT NOT NULL, city VARCHAR(80) NOT NULL, email VARCHAR(255) NOT NULL, PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE one50_shop_domain_model_cart (persistence_object_identifier VARCHAR(40) NOT NULL, user VARCHAR(40) DEFAULT NULL, UNIQUE INDEX UNIQ_D213B8878D93D649 (user), PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE one50_shop_domain_model_cartitem (persistence_object_identifier VARCHAR(40) NOT NULL, cart VARCHAR(40) DEFAULT NULL, product VARCHAR(40) DEFAULT NULL, quantity INT NOT NULL, INDEX IDX_ADEAF65EBA388B7 (cart), INDEX IDX_ADEAF65ED34A04AD (product), PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('CREATE TABLE one50_shop_domain_model_orderitem (persistence_object_identifier VARCHAR(40) NOT NULL, `order` VARCHAR(40) DEFAULT NULL, product VARCHAR(40) DEFAULT NULL, quantity INT NOT NULL, INDEX IDX_D585B3E5F5299398 (`order`), INDEX IDX_D585B3E5D34A04AD (product), PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB');
        $this->addSql('ALTER TABLE one50_shop_domain_model_order ADD CONSTRAINT FK_D32913048D93D649 FOREIGN KEY (user) REFERENCES one50_shop_domain_model_user (persistence_object_identifier)');
        $this->addSql('ALTER TABLE one50_shop_domain_model_product ADD CONSTRAINT FK_E306649B64C19C1 FOREIGN KEY (category) REFERENCES one50_shop_domain_model_category (persistence_object_identifier)');
        $this->addSql('ALTER TABLE one50_shop_domain_model_product_images_join ADD CONSTRAINT FK_BF375517D0794487 FOREIGN KEY (shop_product) REFERENCES one50_shop_domain_model_product (persistence_object_identifier)');
        $this->addSql('ALTER TABLE one50_shop_domain_model_cart ADD CONSTRAINT FK_D213B8878D93D649 FOREIGN KEY (user) REFERENCES one50_shop_domain_model_user (persistence_object_identifier)');
        $this->addSql('ALTER TABLE one50_shop_domain_model_cartitem ADD CONSTRAINT FK_ADEAF65EBA388B7 FOREIGN KEY (cart) REFERENCES one50_shop_domain_model_cart (persistence_object_identifier)');
        $this->addSql('ALTER TABLE one50_shop_domain_model_cartitem ADD CONSTRAINT FK_ADEAF65ED34A04AD FOREIGN KEY (product) REFERENCES one50_shop_domain_model_product (persistence_object_identifier)');
        $this->addSql('ALTER TABLE one50_shop_domain_model_orderitem ADD CONSTRAINT FK_D585B3E5F5299398 FOREIGN KEY (`order`) REFERENCES one50_shop_domain_model_order (persistence_object_identifier)');
        $this->addSql('ALTER TABLE one50_shop_domain_model_orderitem ADD CONSTRAINT FK_D585B3E5D34A04AD FOREIGN KEY (product) REFERENCES one50_shop_domain_model_product (persistence_object_identifier)');
    }

    /**
     * @param Schema $schema
     * @return void
     */
    public function down(Schema $schema)
    {
        // this down() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on "mysql".');
        
        $this->addSql('ALTER TABLE one50_shop_domain_model_product DROP FOREIGN KEY FK_E306649B64C19C1');
        $this->addSql('ALTER TABLE one50_shop_domain_model_orderitem DROP FOREIGN KEY FK_D585B3E5F5299398');
        $this->addSql('ALTER TABLE one50_shop_domain_model_product_images_join DROP FOREIGN KEY FK_BF375517D0794487');
        $this->addSql('ALTER TABLE one50_shop_domain_model_cartitem DROP FOREIGN KEY FK_ADEAF65ED34A04AD');
        $this->addSql('ALTER TABLE one50_shop_domain_model_orderitem DROP FOREIGN KEY FK_D585B3E5D34A04AD');
        $this->addSql('ALTER TABLE one50_shop_domain_model_order DROP FOREIGN KEY FK_D32913048D93D649');
        $this->addSql('ALTER TABLE one50_shop_domain_model_cart DROP FOREIGN KEY FK_D213B8878D93D649');
        $this->addSql('ALTER TABLE one50_shop_domain_model_cartitem DROP FOREIGN KEY FK_ADEAF65EBA388B7');
        $this->addSql('DROP TABLE one50_shop_domain_model_category');
        $this->addSql('DROP TABLE one50_shop_domain_model_order');
        $this->addSql('DROP TABLE one50_shop_domain_model_product');
        $this->addSql('DROP TABLE one50_shop_domain_model_product_images_join');
        $this->addSql('DROP TABLE one50_shop_domain_model_user');
        $this->addSql('DROP TABLE one50_shop_domain_model_cart');
        $this->addSql('DROP TABLE one50_shop_domain_model_cartitem');
        $this->addSql('DROP TABLE one50_shop_domain_model_orderitem');
    }
}